;********************************************************************** 
; Software, non-timer, serial routines based on AN593.
; Ported to module format

;
		RADIX	dec

clockrate equ 4000000         ;define clock rate here
baudrate equ    9600           ;define baud rate here
;
fclk  equ     clockrate/4
;*************************************************************
;baudconsts must be 8-bit values only
baudconst		equ     ((fclk/baudrate)/3 - 2)
baudconst2		equ     ((fclk/baudrate)/2 - 2)
;*************************************************************

		list	p=12F629           ; list directive to define processor
        #include <p12F629.inc>
;
#define _tx     GPIO,GP1
#define _rx     GPIO,GP3

servars	UDATA_SHR

count   RES     1    ;used to count tx and rx data bits
txreg   RES     1    ;used as temp transmit register
rxreg   RES     1    ;received char is saved here
delay   RES     1    ;used to time the baud rate.
;
		GLOBAL	txreg,rxreg
;
sercode	CODE

transmit
		GLOBAL transmit

        movwf   txreg
        bcf     _tx             ; send start bit
        movlw   baudconst
        movwf   delay
        movlw   9
        movwf   count
SendNextBit
txbwait	decfsz  delay, F		; wait bit time
        goto    txbwait
        movlw   baudconst		; precharge delay constant
        movwf   delay
        rrf     txreg, F		; shift bits out (LSB first)
        btfss   STATUS,C
        goto    Setlo
        bsf     _tx
        goto    bitsent
Setlo   bcf     _tx
bitsent decfsz  count, F		; next bit
        goto    SendNextBit
        bsf     _tx             ; send stop bit
        return
;
;
receive
		GLOBAL receive

        movlw   baudconst2			; first time wait 1.5 bit time
        movwf   delay
        movlw   8					; return before stop bit (leaves time for calc)
        movwf   count
stopbit	btfss    _rx
		goto     stopbit			; wait for start bit (previous char)
strtbit	btfsc    _rx
		goto     strtbit			; wait for start bit
rxbaudwait
        decfsz  delay, F			; delay until bit time
        goto    rxbaudwait
        movlw   baudconst			; reload delay constant
        movwf   delay
RecvNextBit
        bcf     STATUS,C
        btfsc   _rx					; sample rx input
        bsf     STATUS,C
        rrf     rxreg, F			; shift in (LSB first)
        decfsz  count, F			; next bit
        goto    rxbaudwait
        return
;
        end


       



